# Changelog
## 1.0.0 [☰](https://github.com/activeadmin/activeadmin/compare/v0.6.3...master) (unreleased)

### Breaking Changes

* Rename `allow_comments` to `comments` for more consistent naming [#3695][] by [@pranas][]
* JavaScript `window.AA` has been removed, use `window.ActiveAdmin` [#3606][] by [@timoschilling][]
* `f.form_buffers` has been removed [#3486][] by [@varyonic][]
* Iconic has been removed [#3553][] by [@timoschilling][]
* `config.show_comments_in_menu` has been removed, see `config.comments_menu` [#4187][] by [@drn][]

### Enhancements

#### Major

* Migration from Metasearch to Ransack [#1979][] by [@seanlinsley][]
* Rails 4 support [#2326][] by many people <3
* Rails 4.2 support [#3731][] by [@gonzedge][] and [@timoschilling][]

#### Minor

* Stream CSV downloads as they're generated [#3038][] by [@craigmcnamara][]
  * Disable streaming in development for easier debugging [#3535][] by [@seanlinsley][]
* Improved code reloading [#3783][] by [@chancancode][]
* Do not auto link to inaccessible actions [#3686][] by [@pranas][]
* Allow to enable comments on per-resource basis [#3695][] by [@pranas][]
* Unify DSL for index `actions` and `actions dropdown: true` [#3463][] by [@timoschilling][]
* Add DSL method `includes` for `ActiveRecord::Relation#includes` [#3464][] by [@timoschilling][]
* BOM (byte order mark) configurable for CSV download [#3519][] by [@timoschilling][]
* Column block on table index is now sortable by default [#3075][] by [@dmitry][]
* Allow Arbre to be used inside ActiveAdmin forms [#3486][] by [@varyonic][]
* Make AA ORM-agnostic [#2545][] by [@johnnyshields][]
* Add multi-record support to `attributes_table_for` [#2544][] by [@zorab47][]
* Table CSS classes are now prefixed to prevent clashes [#2532][] by [@TimPetricola][]
* Allow Inherited Resources shorthand for redirection [#2001][] by [@seanlinsley][]
```ruby
    controller do
      # Redirects to index page instead of rendering updated resource
      def update
        update!{ collection_path }
      end
    end
```

* Accept block for download links [#2040][] by [@potatosalad][]
```ruby
index download_links: ->{ can?(:view_all_download_links) || [:pdf] }
```
* Comments menu can be customized via configuration passed to `config.comments_menu` [#4187][] by [@drn][]

### Security Fixes

* Prevents potential DOS attack via Ruby symbols [#1926][] by [@seanlinsley][]
  * [this isn't an issue for those using Ruby >= 2.2](http://rubykaigi.org/2014/presentation/S-NarihiroNakamura)

### Bug Fixes

* Fixes filters for `has_many :through` relationships [#2541][] by [@shekibobo][]
* "New" action item now only shows up on the index page bf659bc by [@seanlinsley][]
* Fixes comment creation bug with aliased resources 9a082486 by [@seanlinsley][]
* Fixes the deletion of `:if` and `:unless` from filters [#2523][] by [@PChambino][]

### Deprecations

* `ActiveAdmin::Event` (`ActiveAdmin::EventDispatcher`) [#3435][] by [@timoschilling][]
  `ActiveAdmin::Event` will be removed in a future version, ActiveAdmin switched
  to use `ActiveSupport::Notifications`.
  NOTE: The blog parameters has changed:
```ruby
ActiveSupport::Notifications.subscribe ActiveAdmin::Application::BeforeLoadEvent do |event, *args|
  # some code
end

ActiveSupport::Notifications.publish ActiveAdmin::Application::BeforeLoadEvent, "some data"
```

## Previous Changes

Please check [0-6-stable](https://github.com/activeadmin/activeadmin/blob/0-6-stable/CHANGELOG.md) for previous changes.

<!--- The following link definition list is generated by PimpMyChangelog --->
[#1926]: https://github.com/activeadmin/activeadmin/issues/1926
[#1979]: https://github.com/activeadmin/activeadmin/issues/1979
[#2001]: https://github.com/activeadmin/activeadmin/issues/2001
[#2040]: https://github.com/activeadmin/activeadmin/issues/2040
[#2326]: https://github.com/activeadmin/activeadmin/issues/2326
[#2523]: https://github.com/activeadmin/activeadmin/issues/2523
[#2532]: https://github.com/activeadmin/activeadmin/issues/2532
[#2541]: https://github.com/activeadmin/activeadmin/issues/2541
[#2544]: https://github.com/activeadmin/activeadmin/issues/2544
[#2545]: https://github.com/activeadmin/activeadmin/issues/2545
[#3038]: https://github.com/activeadmin/activeadmin/issues/3038
[#3075]: https://github.com/activeadmin/activeadmin/issues/3075
[#3463]: https://github.com/activeadmin/activeadmin/issues/3463
[#3464]: https://github.com/activeadmin/activeadmin/issues/3464
[#3486]: https://github.com/activeadmin/activeadmin/issues/3486
[#3519]: https://github.com/activeadmin/activeadmin/issues/3519
[#3535]: https://github.com/activeadmin/activeadmin/issues/3535
[#3553]: https://github.com/activeadmin/activeadmin/issues/3553
[#3606]: https://github.com/activeadmin/activeadmin/issues/3606
[#3686]: https://github.com/activeadmin/activeadmin/issues/3686
[#3695]: https://github.com/activeadmin/activeadmin/issues/3695
[#3731]: https://github.com/activeadmin/activeadmin/issues/3731
[#3783]: https://github.com/activeadmin/activeadmin/issues/3783
[#4187]: https://github.com/activeadmin/activeadmin/issues/4187
[@PChambino]: https://github.com/PChambino
[@TimPetricola]: https://github.com/TimPetricola
[@chancancode]: https://github.com/chancancode
[@craigmcnamara]: https://github.com/craigmcnamara
[@drn]: https://github.com/drn
[@dmitry]: https://github.com/dmitry
[@gonzedge]: https://github.com/gonzedge
[@johnnyshields]: https://github.com/johnnyshields
[@potatosalad]: https://github.com/potatosalad
[@pranas]: https://github.com/pranas
[@seanlinsley]: https://github.com/seanlinsley
[@shekibobo]: https://github.com/shekibobo
[@timoschilling]: https://github.com/timoschilling
[@varyonic]: https://github.com/varyonic
[@zorab47]: https://github.com/zorab47
